
local LBPCheckFrame = LBP:CreateFrame("frame", "test", UIPARENT, nil, "TOPLEFT", UIPARENT, "TOPLEFT", 0, 0, 1, 1)
-- LBPCheckFrame.text = LBP:CreateFontString(LBPCheckFrame, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", LBPCheckFrame, "TOPLEFT", 600, 0, 200, 700, "LEFT", "TOP", 1, 1, 1, 1)
-- LBPCheckFrame.text:SetText(" ")
-- LBPCheckFrame.text:Hide()

-- function LBPdebug(msg)
	-- LBPCheckFrame.text:SetText(LBPCheckFrame.text:GetText() .."\n"..msg)
-- end

LBPCheckFrame:Show()

local index, x, y, instanceID, name, description, encounterID, rootSectionID, link, TLx,TLy,BRx,BRy, cx, cy, unitX, unitY, abstand, instance, merken, isInstance, instanceType
local encounter_db = {}




function LBP.GetMapEncounter()
	SetMapToCurrentZone()
	
	encounter_db = {}
	index = 1
	
	while EJ_GetMapEncounter(index) do		
		x, y, instanceID, _, _, encounterID = EJ_GetMapEncounter(index)
		y = 1-y
		
		encounter_db[encounterID] = {
			["x"] = x, 
		["y"] = y}
		
		index = index + 1
	end	
	LBP.GetMapDimension()
end

function LBP.GetMapDimension()
	isInstance, instanceType = IsInInstance()
	
	_,TLx,TLy,BRx,BRy = GetCurrentMapZone()
	if isInstance then
		_,TLx,TLy,BRx,BRy = GetCurrentMapDungeonLevel()
	end
	
	-- LBPdebug(TLx)
	-- LBPdebug(TLy)
	-- LBPdebug(BRx)
	-- LBPdebug(BRy)
	if not TLx then
		_,TLx,TLy,BRx,BRy = GetCurrentMapZone()
	end
	
	if TLx then
		cx = abs(TLx-BRx) -- width of zone in yards
		cy = abs(TLy-BRy) -- height of zone in yards	
		
		
		else
		cx = 1.23
		cy = 0
	end
	
	
end





function LBP.EncounterCheck( self )
	-- LBPCheckFrame.text:SetText(" ")
	--instanceID = EJ_GetCurrentInstance()
	
	--instanceType="raid"
	--LBPCheckFrame.text:SetText("")
	
	--SetMapToCurrentZone() 
	--LBPMainFrame:Hide()
	if cx == 1.23 then
		LBP.GetMapDimension()
		return
	end
	
	
	
	
	
	if InCombatLockdown() or WorldMapDetailFrame:IsVisible() or not (instanceType=="raid") or cx == 0 then
		if LBPMainFrame then
			LBPMainFrame:Hide()
		end
		return
		
		else
		-- index = 1
		
		unitX, unitY = GetPlayerMapPosition("player");
		
		
		
		abstand = 10000
		
		
		-- while EJ_GetMapEncounter(index) do		
		-- x, y, instanceID = EJ_GetMapEncounter(index)
		-- y = 1-y
		
		-- if math.sqrt(((x-unitX)*cx)^2 +((y-unitY)*cy)^2) < abstand then
		-- merken = index
		-- abstand = math.sqrt(((x-unitX)*cx)^2 +((y-unitY)*cy)^2)
		-- end
		
		-- index = index + 1
		-- end	
		

		
		
		-- local _, left, top, right, bot = GetCurrentMapZone() 
		-- local unitX, unitY = GetPlayerMapPosition("player") 
		-- unitX = (1.0-unitX)*left+unitX*right 
		-- unitY = (1.0-unitY)*top+unitY*bot
		
		-- LBPdebug(unitX)
		-- LBPdebug(unitY)		
		
		-- for index in pairs(encounter_db) do
		
			-- x = encounter_db[index]["x"]
			-- x = (1.0-x)*left+x*right
			-- y = encounter_db[index]["y"]
			-- y = (1.0-y)*top+y*bot			
			
		
			-- if math.sqrt((x-unitX)^2 +(y-unitY)^2) < abstand then
				-- encounterID = index
				-- abstand = math.sqrt((x-unitX)^2 +(y-unitY)^2)
				-- LBPdebug(abstand)
			-- end
		-- end
		
		
		for index in pairs(encounter_db) do
			if math.sqrt(((encounter_db[index]["x"]-unitX)*cx)^2 +((encounter_db[index]["y"]-unitY)*cy)^2) < abstand then
				encounterID = index
				abstand = math.sqrt(((encounter_db[index]["x"]-unitX)*cx)^2 +((encounter_db[index]["y"]-unitY)*cy)^2)
				-- LBPdebug(abstand)
			end
		end
		
		
		
		--[[
			if not EJ_GetMapEncounter(1) then
			x = 0.5
			y = 0.5
			encounterID = 100
			instanceID = 369
			
			abstand = math.sqrt(((x-unitX)*cx)^2 +((y-unitY)*cy)^2)
			
			x = 0.52
			y = 0.5
			
			if math.sqrt(((x-unitX)*cx)^2 +((y-unitY)*cy)^2) < abstand then
			encounterID = 850
			instanceID = 369			
			
			abstand = math.sqrt(((x-unitX)*cx)^2 +((y-unitY)*cy)^2)
			end
			
			LBPCheckFrame.text:SetText(unitX .." "..unitY)
			end
			
			
		--]]
		
		if abstand < 70 then
			if encounterID ~= LBPMainFrame.encounterID then
				LBPMainFrame.encounterID = encounterID
				LBPMainFrame.instanceID = instanceID
				
				LBPMainFrame:Check()
			end	
			
			
			
			
			
			else
			LBPMainFrame.encounterID = nil
			LBPMainFrame.instanceID = nil
			LBPMainFrame:Hide()
			LBPMainFrame:SetAlpha(1)
		end
		
		
		
		
		--[[
			
			if LBPCheckFrame.text:GetText() then
			LBPCheckFrame.text:SetText(LBPCheckFrame.text:GetText() .. name .." ".. floor(abstand) .."\n")
			else
		LBPCheckFrame.text:SetText(name .." ".. floor(abstand) .."\n")
		end
		--]]
		
		end
		end
		
		LBPCheckFrame:SetScript("OnUpdate", function(self) LBP:EncounterCheck() end)
		
		
		
		
		LBPCheckFrame:SetScript("OnEvent", 
		function(self, event, ... ) 
		LBP.GetMapEncounter()
		if LBPMainFrame then
		LBPMainFrame.encounterID = nil
		LBPMainFrame.instanceID = nil
		end
		end
		)
		
		LBPCheckFrame:RegisterEvent("PLAYER_TALENT_UPDATE")
		--LBPCheckFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
		LBPCheckFrame:RegisterEvent("ZONE_CHANGED");
		LBPCheckFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
		LBPCheckFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
		LBPCheckFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
		
		
		
		
		
		
		
				